# coding: utf-8

"""
    FINBOURNE Identity Service API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import re  # noqa: F401
import io
import warnings

from pydantic.v1 import validate_arguments, ValidationError
from typing import overload, Optional, Union, Awaitable

from typing_extensions import Annotated
from datetime import datetime

from pydantic.v1 import Field, StrictStr

from typing import Optional

from finbourne_identity.models.add_scim_response import AddScimResponse

from finbourne_identity.api_client import ApiClient
from finbourne_identity.api_response import ApiResponse
from finbourne_identity.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class IdentityProviderApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @overload
    async def add_scim(self, api_token_action : Annotated[Optional[StrictStr], Field(description="The action to take. For the API token. Defaults to \"ensure\"")] = None, old_api_token_deactivation : Annotated[Optional[datetime], Field(description="Optional deactivation date for the old API token. Only used if apiTokenAction is \"regenerate\"")] = None, **kwargs) -> AddScimResponse:  # noqa: E501
        ...

    @overload
    def add_scim(self, api_token_action : Annotated[Optional[StrictStr], Field(description="The action to take. For the API token. Defaults to \"ensure\"")] = None, old_api_token_deactivation : Annotated[Optional[datetime], Field(description="Optional deactivation date for the old API token. Only used if apiTokenAction is \"regenerate\"")] = None, async_req: Optional[bool]=True, **kwargs) -> AddScimResponse:  # noqa: E501
        ...

    @validate_arguments
    def add_scim(self, api_token_action : Annotated[Optional[StrictStr], Field(description="The action to take. For the API token. Defaults to \"ensure\"")] = None, old_api_token_deactivation : Annotated[Optional[datetime], Field(description="Optional deactivation date for the old API token. Only used if apiTokenAction is \"regenerate\"")] = None, async_req: Optional[bool]=None, **kwargs) -> Union[AddScimResponse, Awaitable[AddScimResponse]]:  # noqa: E501
        """AddScim: Add SCIM  # noqa: E501

        Generates an API token to be used for SCIM  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.add_scim(api_token_action, old_api_token_deactivation, async_req=True)
        >>> result = thread.get()

        :param api_token_action: The action to take. For the API token. Defaults to \"ensure\"
        :type api_token_action: str
        :param old_api_token_deactivation: Optional deactivation date for the old API token. Only used if apiTokenAction is \"regenerate\"
        :type old_api_token_deactivation: datetime
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: AddScimResponse
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the add_scim_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        if async_req is not None:
            kwargs['async_req'] = async_req
        return self.add_scim_with_http_info(api_token_action, old_api_token_deactivation, **kwargs)  # noqa: E501

    @validate_arguments
    def add_scim_with_http_info(self, api_token_action : Annotated[Optional[StrictStr], Field(description="The action to take. For the API token. Defaults to \"ensure\"")] = None, old_api_token_deactivation : Annotated[Optional[datetime], Field(description="Optional deactivation date for the old API token. Only used if apiTokenAction is \"regenerate\"")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """AddScim: Add SCIM  # noqa: E501

        Generates an API token to be used for SCIM  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.add_scim_with_http_info(api_token_action, old_api_token_deactivation, async_req=True)
        >>> result = thread.get()

        :param api_token_action: The action to take. For the API token. Defaults to \"ensure\"
        :type api_token_action: str
        :param old_api_token_deactivation: Optional deactivation date for the old API token. Only used if apiTokenAction is \"regenerate\"
        :type old_api_token_deactivation: datetime
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(AddScimResponse, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'api_token_action',
            'old_api_token_deactivation'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_scim" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('api_token_action') is not None:  # noqa: E501
            _query_params.append(('apiTokenAction', _params['api_token_action']))

        if _params.get('old_api_token_deactivation') is not None:  # noqa: E501
            if isinstance(_params['old_api_token_deactivation'], datetime):
                _query_params.append(('oldApiTokenDeactivation', _params['old_api_token_deactivation'].strftime(self.api_client.configuration.datetime_format)))
            else:
                _query_params.append(('oldApiTokenDeactivation', _params['old_api_token_deactivation']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['oauth2']  # noqa: E501

        _response_types_map = {
            '200': "AddScimResponse",
            '400': "LusidValidationProblemDetails",
        }

        return self.api_client.call_api(
            '/api/identityprovider/scim', 'PUT',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @overload
    async def remove_scim(self, **kwargs) -> None:  # noqa: E501
        ...

    @overload
    def remove_scim(self, async_req: Optional[bool]=True, **kwargs) -> None:  # noqa: E501
        ...

    @validate_arguments
    def remove_scim(self, async_req: Optional[bool]=None, **kwargs) -> Union[None, Awaitable[None]]:  # noqa: E501
        """RemoveScim: Remove SCIM  # noqa: E501

        Deactivates any existing SCIM API token  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.remove_scim(async_req=True)
        >>> result = thread.get()

        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the remove_scim_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        if async_req is not None:
            kwargs['async_req'] = async_req
        return self.remove_scim_with_http_info(**kwargs)  # noqa: E501

    @validate_arguments
    def remove_scim_with_http_info(self, **kwargs) -> ApiResponse:  # noqa: E501
        """RemoveScim: Remove SCIM  # noqa: E501

        Deactivates any existing SCIM API token  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.remove_scim_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """

        _params = locals()

        _all_params = [
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method remove_scim" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['oauth2']  # noqa: E501

        _response_types_map = {}

        return self.api_client.call_api(
            '/api/identityprovider/scim', 'DELETE',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
