# coding: utf-8

"""
    FINBOURNE Identity Service API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict
from pydantic.v1 import BaseModel, Field, StrictBool, StrictInt

class PasswordPolicyResponseComplexity(BaseModel):
    """
    PasswordPolicyResponseComplexity
    """
    min_length: StrictInt = Field(..., alias="minLength", description="The minimum length for a password")
    exclude_first_name: StrictBool = Field(..., alias="excludeFirstName", description="Rule determining whether a user's first name should be permitted in their password")
    exclude_last_name: StrictBool = Field(..., alias="excludeLastName", description="Rule determining whether a user's last name should be permitted in their password")
    __properties = ["minLength", "excludeFirstName", "excludeLastName"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PasswordPolicyResponseComplexity:
        """Create an instance of PasswordPolicyResponseComplexity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PasswordPolicyResponseComplexity:
        """Create an instance of PasswordPolicyResponseComplexity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PasswordPolicyResponseComplexity.parse_obj(obj)

        _obj = PasswordPolicyResponseComplexity.parse_obj({
            "min_length": obj.get("minLength"),
            "exclude_first_name": obj.get("excludeFirstName"),
            "exclude_last_name": obj.get("excludeLastName")
        })
        return _obj
